
#import <Foundation/NSObject.h>
#import <WebObjects/WOAssociation.h>
#import <WebObjects/WODirectAction.h>
#import <WebObjects/WOSession.h>
#import <Foundation/NSDate.h>

@class WOComponent;
@class NSArray;
@class WOStopWatch;

@interface WOAssociation (DebuggingIdentification)
- (NSString*)declarationName;
- (NSString*)declarationType;
- (NSString*)bindingName;
-  (NSString*)_keyPath;
@end

@interface WOKeyValueAssociation : WOAssociation {
    NSString *_keyPath;
}
@end

@interface WXKeyValueAssociation : WOKeyValueAssociation {
}
@end

@interface WOBindingNameAssociation : WOAssociation {
    NSString* _parentBindingName;
    NSString* _keyPath;
}
@end

@interface WXSession : WOSession {
}
@end

@interface WXDirectAction : WODirectAction {
}
@end

@interface WXApplication : WOApplication {
}
@end


@interface WXBindingNameAssociation: WOBindingNameAssociation {
}
@end

@interface WXAssociationTimeInterval : NSObject {
    WXKeyValueAssociation* _association;
    NSString* _componentName;
    WOStopWatch* _pushTimeStopWatch;
    WOStopWatch* _pullTimeStopWatch;
}

+ (NSMutableArray *)thisRequestResponseLoopTimings;

- (void)startPullStopWatch;

- (void)stopPullStopWatch;

- (void)startPushStopWatch;

- (void)stopPushStopWatch;

@end
